<?php

require_once 'base/EnderecoparcEntityBase.php';

/**
 * This class has been auto-generated by Setforms
 * 
 * @package Entity
 * 
 * @author  cristianefaria
 */
class EnderecoparcEntity extends EnderecoparcEntityBase
{

    private $_nrEndereco;

    private $_endereco;
    private $_numero;
    private $_complemento;


	public static function novoCodigo(){
		
		return Enderecoparc::novoCodigo();
		
		
	}
	
	public static function deleta_filho_enderecoparc($nrenderecoparc){		
		try{
		    Enderecoparc::deleta_filho_enderecoparc($nrenderecoparc);
        } catch(Exception $e) {
            throw $e;
        }
			
	}
	
	public static function validaCdTipoEndereco($nrparcnegocio, $nrenderecoparc, $novoisnull = null){
		try{
                    return Enderecoparc::validaCdTipoEndereco($nrparcnegocio, $nrenderecoparc, $novoisnull);
                }catch(Exception $e){
                    throw $e;
                }
		
	}
	
	public static function verificaSeENovo($nrenderecoparc){
				
		return Enderecoparc::verificaSeENovo($nrenderecoparc);
		
	}


    /**
     * Retorna uma instancia de EnderecoparcEntity
     *
     * @param string $nrEnderecoParc Numero do EnderecoParc.
     * @param string $nrOrg          Numero da Organizacao.
     *
     * @return EnderecoparcEntity | null
     *
     * @author thalesvalias - 02/04/2012
     */
    public function retornaEnderecoParceiro($nrEnderecoParc, $nrOrg){
        $enderecoParc = Enderecoparc::retornaEnderecoParceiro($nrEnderecoParc, $nrOrg);

        return $enderecoParc;
    }


    /**
     * Retorna uma instancia de EnderecoparcEntity por tipo de endereco
     *
     * @param integer $nrOrg        Numero da Organizacao.
     * @param integer $nrParceiro   Numero do EnderecoParc.
     * @param string  $tipoEndereco Tipo de endereco.
     *
     * @return EnderecoparcEntity | null
     *
     * @author thalesvalias - 12/04/2012
     */
    public function retornaEnderecoParceiroPorTipo($nrOrg, $nrParceiro, $tipoEndereco){
        $enderecoParceiro = Enderecoparc::retornaEnderecoParceiroPorTipo($nrOrg, $nrParceiro, $tipoEndereco);

        return $enderecoParceiro;
    }


    public static function consultaEnderecoPorCep($cep, $nrorg)
    {
        try{
            return Enderecoparc::consultaEnderecoPorCep($cep, $nrorg);
        } catch(PDOException $e) {
            throw $e;
        }
    }


    public function separaDsEndereco() {
        // $endereco = $this->getDsendereco();

        $array = array($this->getDsendereco());

        $search = array(',');
        $replace = '';

        for ($i = 0; $i < 1; $i++) {
            $end = "";
            $num = "";
            $comp = "";
            for ($count = 0; $count < strlen($array[$i]); $count++) {
                if (is_numeric($array[$i][$count]) && empty ($end)){
                    $end = substr($array[$i], 0, $count);
                }
                if (!is_numeric($array[$i][$count]) && !empty ($end)) {
                    $num = substr($array[$i], strlen($end), ($count - strlen($end)));
                    if (strlen($array[$i]) > (strlen($end) + strlen($num))) {
                        $comp = substr($array[$i], $count);
                    }
                    $this->_endereco = str_replace($search, $replace, $end);
                    $this->_numero = $num;
                    $this->_complemento = $comp;

                    break;
                } else{
                    if (strlen($array[$i]) == ($count + 1)) {
                        $num = substr($array[$i], strlen($end));
                        $this->_endereco = str_replace($search, $replace, $end);
                        $this->_numero = $num;
                        $this->_complemento = $comp;
                    }
                }
            }
        }

    }


    public function getComplemento() {
        return $this->_complemento;
    }


    public function getEndereco() {
        return $this->_endereco;
    }


    public function getNumero() {
        return $this->_numero;
    }

    public function getNrendereco(){
        return $this->_nrEndereco;
    }

    public function criaEnderecoParc(
        $nrOrg, $nrParceiro, $cdTipoEndereco, $cdPais = null, $sgEstado = null, $cdMunicipio = null, $bairro = null,
        $cep = null, $descEndereco = null
    ){
        $endereco = new self();
        $endereco->setNrorg($nrOrg);
        $endereco->setNrparcnegocio($nrParceiro);
        $endereco->setCdtipoendereco($cdTipoEndereco);
        $endereco->setCdpais($cdPais);
        $endereco->setSgestado($sgEstado);
        $endereco->setCdmunicipio($cdMunicipio);
        $endereco->setNmbairroendereco($bairro);
        $endereco->setNrcependereco($cep);
        $endereco->setDsendereco($descEndereco);

        $endereco->persist();

        $this->_nrEndereco = $endereco->getNrenderecoparc();
        unset($endereco);


    }

    public function setEnderecoParceiro($nrorg, $nrparceiro, $cdtipoendereco, $cdpais, $sgestado, $cdmunicipio,
                                           $bairro, $cep, $descEndereco)
    {
        $this->setNrorg($nrorg);
        $this->setNrparcnegocio($nrparceiro);
        $this->setCdtipoendereco($cdtipoendereco);
        $this->setCdpais($cdpais);
        $this->setSgestado($sgestado);
        $this->setCdmunicipio($cdmunicipio);
        $this->setNmbairroendereco($bairro);
        $this->setNrcependereco($cep);
        $this->setDsendereco($descEndereco);
    }

    /**
     * @param $nrorg
     * @param $nrparceiro
     * @return EnderecoparcEntity
     * @autor jorgefonseca
     */
    public static function getEnderecoParceiro($nrorg, $nrparceiro) {
        $enderecoparc = self::getEntityByWhere('NRORG = ? AND NRPARCNEGOCIO = ?', array($nrorg, $nrparceiro));
        return $enderecoparc;
    }

}

